package idiomdemo.service.rest;

import idiomdemo.service.CalculationService;

import javax.servlet.ServletContext;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;

import org.springframework.web.context.support.WebApplicationContextUtils;

@Path("calculationservice")
public class CalculationServiceRest {

	
	@GET @Produces("text/plain")
	public String getServerTimeTest() {
		return String.format("getSeverTime() : %d", System.currentTimeMillis());
	}
	
	@GET @Produces("text/plain")
	@Path("getservertime/{message}")
	public String getServerTime (@Context ServletContext context, @PathParam("message") String message) 
	{
		CalculationService service = 
			(CalculationService)WebApplicationContextUtils.getRequiredWebApplicationContext(context).getBean("calculationService");
		
		String serverTime = message + " : " + service.getServerTime();
		return serverTime;
	}
	
	@GET @Produces("text/plain")
	@Path("calculatebmi/{height}/{weight}")
	public String calculateBMI (@Context ServletContext context, 
			@PathParam("height") Double height,
			@PathParam("weight") Double weight) 
	{
		CalculationService service = 
			(CalculationService)WebApplicationContextUtils.getRequiredWebApplicationContext(context).getBean("calculationService");
		
		//Double bmi = service.calculateBMI(height, weight);
		Double bmi = service.calculateBMIWithRules(height, weight);
		
		return bmi.toString();
	}
}
